///////////////////////////////////////////////////////////////////////////////////////
//
//	Javascript functions, used by html page to get at java app.
//
///////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////
//	Globals
///////////////////////////////////////////////////////////////////////////////////////
var	Enable3dMode = true;
var	EnableAudio = true;
var	StartingLevel = "1";
var	AudioUnChecked = "WebImages/audio_00.png";
var	AudioChecked = "WebImages/audio_02.png";
var	Use3dUnChecked = "WebImages/3dmode_00.png";
var	Use3dChecked = "WebImages/3dmode_02.png";
var	Enable3dModeCookieString = "Use3dMode";
var	EnableAudioCookieString = "UseAudio";
var	StartingLevelCookieString = "StartingLevel";
var CookieExpDate;
var	FirstTimeRun = false;
var	AppletInitialized = false;
var RebootRequired = false;



///////////////////////////////////////////////////////////////////////////////////////
//
//	AppletInitComplete()
//	Set applet init flag.
//
///////////////////////////////////////////////////////////////////////////////////////
function AppletInitComplete()
{
	AppletInitialized = true;

} // AppletInitComplete()



///////////////////////////////////////////////////////////////////////////////////////
//
//	GetDefaults()
//	Get defaults.
//
///////////////////////////////////////////////////////////////////////////////////////
function GetDefaults()
{


	///////////////////////////////////////////////////////////////////////////////////////
	// get 2d/3d choice
	///////////////////////////////////////////////////////////////////////////////////////
	if ( GetCookie( Enable3dModeCookieString ) == null )
	{
		Enable3dMode = true;
		FirstTimeRun = true;
	}
	else if ( GetCookie( Enable3dModeCookieString ) == "true" )
	{
		Enable3dMode = true;
	}
	else
	{
		Enable3dMode = false;
	}

	
	///////////////////////////////////////////////////////////////////////////////////////
	// get audio choice
	///////////////////////////////////////////////////////////////////////////////////////
	if ( GetCookie( EnableAudioCookieString ) == null )
	{
		EnableAudio = true;
	}
	else if ( GetCookie( EnableAudioCookieString ) == "true" )
	{
		EnableAudio = true;
	}
	else
	{
		EnableAudio = false;
	}

	
	///////////////////////////////////////////////////////////////////////////////////////
	// get starting level choice
	///////////////////////////////////////////////////////////////////////////////////////
	StartingLevel = GetCookie( StartingLevelCookieString );
	if ( StartingLevel == null )
	{
		StartingLevel = "1";
	}
	
} // GetDefaults()



///////////////////////////////////////////////////////////////////////////////////////
//
//	ApplyDefaults()
//	Apply defaults.
//
///////////////////////////////////////////////////////////////////////////////////////
function ApplyDefaults()
{


	///////////////////////////////////////////////////////////////////////////////////////
	// apply 2d/3d choice
	///////////////////////////////////////////////////////////////////////////////////////
	if ( Enable3dMode == true )
	{
		document.images["Enable3dMode"].src = Use3dChecked;
	}
	else
	{
		document.images["Enable3dMode"].src = Use3dUnChecked;
	}
	if ( AppletInitialized )
	{
		document.WTJavaApplet.Set3dMode( Enable3dMode );
	}

	
	///////////////////////////////////////////////////////////////////////////////////////
	// apply audio choice
	///////////////////////////////////////////////////////////////////////////////////////
	if ( EnableAudio == true )
	{
		document.images["EnableAudio"].src = AudioChecked;
	}
	else
	{
		document.images["EnableAudio"].src = AudioUnChecked;
	}
	if ( AppletInitialized )
	{
		document.WTJavaApplet.SetAudio( EnableAudio );
	}

	
	///////////////////////////////////////////////////////////////////////////////////////
	// apply starting level choice
	///////////////////////////////////////////////////////////////////////////////////////
	ApplyNewStartingLevel();


	///////////////////////////////////////////////////////////////////////////////////////
	// 
	///////////////////////////////////////////////////////////////////////////////////////
	document.images["ButtonRestartGame"].src = "WebImages/2start_00.png";
	document.images["ButtonQuitGame"].src = "WebImages/quit_00.png";

} // ApplyDefaults()



///////////////////////////////////////////////////////////////////////////////////////
//
//	Force2d()
//	Force into 2d mode.
//
///////////////////////////////////////////////////////////////////////////////////////
function Force2d()
{

	// allow force2d only if its the first time run
	if ( FirstTimeRun == true )
	{
		Enable3dMode = false;
		document.images["Enable3dMode"].src = Use3dUnChecked;
	}
		
} // Force2d()



///////////////////////////////////////////////////////////////////////////////////////
//
//	begin()
//	Starts up the web driver.
//
///////////////////////////////////////////////////////////////////////////////////////
function begin()
{

	// check if reboot required
	{
	
		// locals	
		var	SetupOk = true;
	
		// check if our jar has been loaded
		SetupOk &= document.WTCheck.CheckIntegrity();
		
		//
		if ( SetupOk == false )
		{
			RebootRequired = true;
			alert( "Java requires you to restart your system when new components are installed. You will need to do this before running this application for the first time." );
			return;
		}
	}

	// check if driver installed ok
	if ( driverExists() == false )
	{
		if ( confirm( "Wild Tangent webdriver may not be properly installed. Launch troubleshooting web page?" ) == true )
		{
			window.open( "trouble.html" );
		}
		return;
	}

	// get app defaults
	GetDefaults();

	// init cookie expiry data
	CookieExpDate = new Date();
	FixCookieDate( CookieExpDate ); 
	CookieExpDate.setTime( CookieExpDate.getTime() + ( 365 * 24 * 60 * 60 * 1000 ) );

	// startup our java app
	document.WTJavaApplet.begin( document.wtObject );
	
	// apply default settings
	ApplyDefaults();
	
	// update top lists
	//UpdateTopLists();

} // begin()



///////////////////////////////////////////////////////////////////////////////////////
//
//	end()
//	Shuts down the web driver.
//
///////////////////////////////////////////////////////////////////////////////////////
function end()
{

	// shut down wt driver
	if ( AppletInitialized )
	{
		document.WTJavaApplet.end();
	}

} // end()



///////////////////////////////////////////////////////////////////////////////////////
//
//	SaveBestTable()
//	Save out top score/jewels/level table.
//
///////////////////////////////////////////////////////////////////////////////////////
function SaveBestTable(
	CookieName,
	Data )
{
	SetCookie( CookieName, Data, CookieExpDate );

} // SaveBestTable()



///////////////////////////////////////////////////////////////////////////////////////
//
//	ReloadBestTable()
//	Reload best table data.
//
///////////////////////////////////////////////////////////////////////////////////////
function ReloadBestTable()
{

	// locals
	var	Score, Jewels, Level;

	// get best score
	Score = GetCookie( "BestScore" );
	if ( Score != null )
	{
		Score = parseInt( Score );
	}
	else
	{
		Score = 0;
	}	
		
	// get best jewels
	Jewels = GetCookie( "BestJewels" );
	if ( Jewels != null )
	{
		Jewels = parseInt( Jewels );
	}
	else
	{
		Jewels = 0;
	}	
		
	// get best level
	Level = GetCookie( "BestLevel" );
	if ( Level != null )
	{
		Level = parseInt( Level );
	}
	else
	{
		Level = 0;
	}	

	// update table	
	if ( AppletInitialized )
	{
		document.WTJavaApplet.ReloadBestTable( Score, Jewels, Level );
	}	
	
} // ReloadBestTable()



///////////////////////////////////////////////////////////////////////////////////////
//
//	MouseClick()
//	Handle mouse clicks.
//
///////////////////////////////////////////////////////////////////////////////////////
function MouseClick()
{

	// send mouse click to java app
	if ( AppletInitialized )
	{
		document.WTJavaApplet.MouseClick();
	}

} // MouseClick()
	


///////////////////////////////////////////////////////////////////////////////////////
//
//	Toggle3dMode()
//	Toggles 3d mode on/off.
//
///////////////////////////////////////////////////////////////////////////////////////
function Toggle3dMode()
{

	// adjust the java app
	Enable3dMode = !Enable3dMode;
	if ( AppletInitialized )
	{
		document.WTJavaApplet.Set3dMode( Enable3dMode );
	}
	
	// adjust the on screen checkbox
	if ( Enable3dMode == 0 )
	{
		document.images["Enable3dMode"].src = Use3dUnChecked;
	}
	else
	{		
		document.images["Enable3dMode"].src = Use3dChecked;
	}
	
	// write out the cookie
	SetCookie( Enable3dModeCookieString, Enable3dMode, CookieExpDate );

} // Toggle3dMode()
	


///////////////////////////////////////////////////////////////////////////////////////
//
//	ToggleAudio()
//	Toggles audio on/off.
//
///////////////////////////////////////////////////////////////////////////////////////
function ToggleAudio()
{

	// adjust the java app
	EnableAudio = !EnableAudio;
	if ( AppletInitialized )
	{
		document.WTJavaApplet.SetAudio( EnableAudio );
	}
	
	// adjust the on screen checkbox
	if ( EnableAudio == 0 )
	{
		document.images["EnableAudio"].src = AudioUnChecked;
	}
	else
	{		
		document.images["EnableAudio"].src = AudioChecked;
	}

	// write out the cookie
	SetCookie( EnableAudioCookieString, EnableAudio, CookieExpDate );

} // ToggleAudio()



///////////////////////////////////////////////////////////////////////////////////////
//
//	ToggleAudio2()
//	
//
///////////////////////////////////////////////////////////////////////////////////////
function ToggleAudio2()
{

} // ToggleAudio2()



///////////////////////////////////////////////////////////////////////////////////////
//
//	RestartGame()
//	Restarts game.
//
///////////////////////////////////////////////////////////////////////////////////////
function RestartGame()
{

	// start a new game
	if ( AppletInitialized )
	{
		document.WTJavaApplet.StartGame();
	}
	
	// display reboot required message if needed
	if ( RebootRequired == true )
	{
		alert( "Java requires you to restart your system before running this application." );
	}

} // RestartGame()

	

///////////////////////////////////////////////////////////////////////////////////////
//
//	QuitGame()
//	Quits game.
//
///////////////////////////////////////////////////////////////////////////////////////
function QuitGame()
{
	window.close();

} // QuitGame()



///////////////////////////////////////////////////////////////////////////////////////
//
//	DecStartingLevel()
//	Decrease the starting level.
//
///////////////////////////////////////////////////////////////////////////////////////
function DecStartingLevel()
{
	if ( AppletInitialized )
	{
		StartingLevel = document.WTJavaApplet.DecStartingLevel();
		ApplyNewStartingLevel();
		SetCookie( StartingLevelCookieString, StartingLevel, CookieExpDate );
	}
	
} // DecStartingLevel()



///////////////////////////////////////////////////////////////////////////////////////
//
//	IncStartingLevel()
//	Increase the starting level.
//
///////////////////////////////////////////////////////////////////////////////////////
function IncStartingLevel()
{
	if ( AppletInitialized )
	{
		StartingLevel = document.WTJavaApplet.IncStartingLevel();
		ApplyNewStartingLevel();
		SetCookie( StartingLevelCookieString, StartingLevel, CookieExpDate );
	}

} // IncStartingLevel()



///////////////////////////////////////////////////////////////////////////////////////
//
//	ApplyNewStartingLevel()
//	Apply the new starting level.
//
///////////////////////////////////////////////////////////////////////////////////////
function ApplyNewStartingLevel()
{
	
	if ( AppletInitialized )
	{

		// locals	
		var	NumericStartingLevel;
	
		// get numeric starting level, correcting it if its bogus
		NumericStartingLevel = parseInt( StartingLevel );
		if ( ( NumericStartingLevel < 1 ) || ( NumericStartingLevel > 9 ) )
		{
			NumericStartingLevel = 1;
			StartingLevel = NumericStartingLevel;
		}
	
		// apply new starting level
		document.WTJavaApplet.SetStartingLevel( NumericStartingLevel );
	}
	
} // ApplyNewStartingLevel()
